package cn.rankin.userservice.service;

import cn.rankin.data.api.user.entity.UserDevice;
import cn.rankin.userservice.helper.RaStringHelper;
import cn.rankin.userservice.repository.UserDeviceRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service
public class UserDeviceService
{
    @Autowired
    private UserDeviceRepository userDeviceRepository;

    /**
     * Find device
     * @param uid
     * @param deviceCode
     * @param deviceModel
     * @param deviceMfrs
     * @param deviceBrand
     * @return
     */
    public UserDevice findDevice(String uid,String deviceCode,String deviceModel,String deviceMfrs,String deviceBrand)
    {
        if(RaStringHelper.isNull(uid))
        {
            return null;
        }
        if(RaStringHelper.isNull(deviceCode))
        {
            return null;
        }
        if(RaStringHelper.isNull(deviceModel))
        {
            return null;
        }

        UserDevice userDevice = userDeviceRepository.findUserDevice(uid,deviceCode,deviceModel,deviceMfrs,deviceBrand);
        if(userDevice != null)
        {
            return userDevice;
        }
        else
            {
            userDevice = new UserDevice();
            userDevice.setUserId(uid);
            userDevice.setGmtCreated(new Date());
            userDevice.setDeviceCode(deviceCode);
            userDevice.setDeviceModel(deviceModel);
            userDevice.setDeviceMfrs(deviceMfrs);
            userDevice.setDeviceBrand(deviceBrand);
            userDevice.setNum(1);
            userDeviceRepository.save(userDevice);

            return null;
        }
    }

    /**
     * Updates device
     * @param uid
     * @param deviceCode
     * @param deviceModel
     * @param deviceMfrs
     * @param deviceBrand
     * @param bingdingNum
     * @return
     */
    public int updateDevice(String uid,String deviceCode,String deviceModel,String deviceMfrs,String deviceBrand,int bingdingNum)
    {
        if(RaStringHelper.isNull(uid))
        {
            return 0;
        }
        if(RaStringHelper.isNull(deviceCode))
        {
            return 0;
        }
        if(RaStringHelper.isNull(deviceModel))
        {
            return 0;
        }

        int updateRet = userDeviceRepository.updateDevice(uid,deviceCode,deviceModel,deviceMfrs,deviceBrand,bingdingNum);

        return   updateRet;
    }

}
